;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; EMACS INITIALIZATION FILE
;; Written by Gabriel Foust, August 30, 2004

; hilite selected region
(setq-default transient-mark-mode t)

; use font colors for editing code
(global-font-lock-mode)

; show matching parens (and braces)
(show-paren-mode)

; mouse wheel support
(cond (window-system (mwheel-install)))

; use text mode by default
(setq default-major-mode 'text-mode)

; when editing text, wrap automatically
(add-hook 'text-mode-hook 'turn-on-auto-fill)

; cperl is a better perl mode
(add-hook 'perl-mode-hook 'cperl-mode)

; useful key mappings
(global-set-key '[delete] 'delete-char)
(global-set-key '[kp-delete] 'delete-char)
(global-set-key '[end] 'end-of-line)
(global-set-key '[home] 'beginning-of-line)
(global-set-key "\C-cg" 'goto-line)
(global-set-key "\C-cc" 'comment-region)
(global-set-key "\C-cp" 'compile)
(global-set-key '[f2] 'shell)
(global-set-key '[f9] 'bury-buffer)
(global-set-key '[S-up] (lambda () (interactive) (scroll-down 1)))
(global-set-key '[S-down] (lambda () (interactive) (scroll-up 1)))

; paren (and brace) matching
(defun match-paren (arg)
  "Go to the matching parenthesis if on parenthesis otherwise insert %."
  (interactive "p")
  (cond ((or (looking-at "\\s\(")
	     (looking-at "\\s\{")
	     (looking-at "\\s\[")) (forward-list 1) (backward-char 1))
        ((or (looking-at "\\s\)")
	     (looking-at "\\s\}")
	     (looking-at "\\s\]")) (forward-char 1) (backward-list 1))
        (t (self-insert-command (or arg 1)))))

(global-set-key "%" 'match-paren)
